## libdrumstick 2.9.1

=== debian/changelog ===
libdrumstick (2.9.1-1) unstable; urgency=medium

  * New upstream version 2.9.1
  * Bump Standards-Version to 4.7.0
  * Change B-D pkg-config -> pkgconf

 -- Dennis Braun <snd@debian.org>  Fri, 13 Sep 2024 20:50:03 +0200

libdrumstick (2.9.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062273

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 18:53:30 +0000

## libdrumstick 2.10.0

=== CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

cmake_minimum_required(VERSION 3.16)

project( Drumstick
    VERSION 2.10.0
    LANGUAGES CXX
    DESCRIPTION "MIDI C++ Libraries for Qt"
    HOMEPAGE_URL "https://drumstick.sourceforge.io"
)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_admin)
include(SCMRevision)
include(CTest)
include(GNUInstallDirs)

set(RELEASE_DATE "December 22, 2024")
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if (WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8") #/source-charset:utf-8 /execution-charset:utf-8
endif()

#[==[
compiler and linker extra checks:
if(UNIX AND NOT APPLE)
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -pedantic")
        set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed -Wl,-z,defs")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed -Wl,-z,defs")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed -Wl,--no-undefined -Wl,-z,defs")
    endif()
endif()
#]==]

add_definitions(-DVERSION=${PROJECT_VERSION})
if (DEFINED PROJECT_WC_REVISION)
    add_definitions(-DREVISION=${PROJECT_WC_REVISION})
endif()

if (UNIX)
    set(_DOCS_INIT ON)
else()
    set(_DOCS_INIT OFF)
endif()

set(_DBUS_INIT OFF)
if (UNIX AND NOT APPLE)
    set(_PULSE_INIT ON)
    set(_PW_INIT ON)
else ()
    set(_PULSE_INIT OFF)
    set(_PW_INIT OFF)
endif ()

if (APPLE)
    set(_FRAMEWORKS_INIT ON)
else()
    set(_FRAMEWORKS_INIT OFF)
endif()

# ALSA Sequencer is only available on Linux
if (${CMAKE_SYSTEM} MATCHES "Linux")
    set(_BUILD_ALSA_INIT ON)
else()
    set(_BUILD_ALSA_INIT OFF)
endif()

option(BUILD_DOCS "Build Doxygen documentation and man pages" ${_DOCS_INIT})
option(BUILD_UTILS "Build Utilities and Examples" ON)
option(BUILD_FRAMEWORKS "Build macOS style frameworks" ${_FRAMEWORKS_INIT})
option(BUILD_ALSA "Build the libdrumstick-alsa library (Linux only)" ${_BUILD_ALSA_INIT})
option(BUILD_FILE "Build the libdrumstick-file library" ON)
option(BUILD_RT "Build the libdrumstick-rt library" ON)
option(BUILD_WIDGETS "Build the libdrumstick-widgets library" ON)
option(STATIC_DRUMSTICK "Build and link static libraries instead of shared" OFF)
option(USE_DBUS "Include DBus support (required for RealtimeKit)" ${_DBUS_INIT})
option(USE_PULSEAUDIO "Build Sonivox RT backend (if PulseAudio is available)" ${_PULSE_INIT})
option(USE_PIPEWIRE "Build RT backends with PipeWire support" ${_PW_INIT})
option(USE_FLUIDSYNTH "Build FluidSynth RT backend (if available)" ON)
option(USE_NETWORK "Build Network RT backend (if QtNetwork is available)" ON)
option(USE_SONIVOX "Build Sonivox RT backend (if Sonivox is available)" ${_PULSE_INIT})
option(USE_QT5 "Prefer building with Qt5 instead of Qt6")

if (BUILD_WIDGETS AND NOT BUILD_RT)
    message(FATAL_ERROR "libdrumstick-widgets requires libdrumstick-rt")
endif()

if(STATIC_DRUMSTICK)
    set(BUILD_SHARED_LIBS OFF)
    add_definitions(-DDRUMSTICK_STATIC)
    message(STATUS "Building static libraries")
else()
    set(BUILD_SHARED_LIBS ON)
    if (BUILD_FRAMEWORKS)
        message(STATUS "Building macOS style frameworks")
    else()
        message(STATUS "Building unix dynamic libraries")
    endif()
endif()

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    set(CMAKE_FRAMEWORK ${BUILD_FRAMEWORKS})
endif()

if (UNIX AND NOT APPLE)
    if ((USE_PULSEAUDIO AND NOT USE_SONIVOX) OR (USE_SONIVOX AND NOT USE_PULSEAUDIO))
        message(FATAL_ERROR "Wrong combination of USE_SONIVOX and USE_PULSEAUDIO options")
    endif()
endif()

if (USE_QT5)
    find_package(QT NAMES Qt5 REQUIRED)
else()
    find_package(QT NAMES Qt6 REQUIRED)
endif()

if (QT_VERSION VERSION_LESS 6.0.0)
    find_package(Qt5 5.9 COMPONENTS Core REQUIRED)
else()
    if (QT_VERSION VERSION_LESS 6.2.0)
       message (FATAL_ERROR "Qt6 >= 6.2 is required, or use Qt5 >= 5.9")
    endif()
    find_package(Qt6 6.2 COMPONENTS Core REQUIRED)
    if (BUILD_FILE)
        find_package(Qt6Core5Compat REQUIRED)
    endif()
endif()

message(STATUS "Found Qt version = ${QT_VERSION}")

set(HAVE_DBUS OFF)
if(BUILD_ALSA AND USE_DBUS)
    find_package(Qt${QT_VERSION_MAJOR}DBus REQUIRED)
    if (${Qt${QT_VERSION_MAJOR}DBus_FOUND})
        set(HAVE_DBUS ON)
        message(STATUS "Found QtDBus version = ${Qt${QT_VERSION_MAJOR}DBus_VERSION}")
    endif()
endif()

set(HAVE_NETWORK OFF)
if(BUILD_RT AND USE_NETWORK)
    find_package(Qt${QT_VERSION_MAJOR}Network REQUIRED)
    if(Qt${QT_VERSION_MAJOR}Network_FOUND)
        message(STATUS "Found QtNetwork version = ${Qt${QT_VERSION_MAJOR}Network_VERSION}")
        set(HAVE_NETWORK ON)
    else()
        message(FATAL_ERROR "QtNetwork library not available. Network RT backend can't be built.")
    endif()
endif()

find_package(PkgConfig REQUIRED)
if(PKG_CONFIG_FOUND)
    message(STATUS "Program pkg-config ${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
else()
    message(FATAL_ERROR "Program pkg-config not found")
endif()

# ALSA Sequencer is only available on Linux
if (BUILD_ALSA AND (${CMAKE_SYSTEM} MATCHES "Linux"))
    pkg_check_modules(ALSA REQUIRED IMPORTED_TARGET alsa>=1.0.0)
    if(ALSA_FOUND)
        message(STATUS "Found ALSA version = ${ALSA_VERSION}")
    else()
        message(FATAL_ERROR "library libdrumstick-alsa requested, but ALSA Sequencer was not found")
    endif()
endif()

set(HAVE_PULSEAUDIO OFF)
if(BUILD_RT AND PKG_CONFIG_FOUND AND UNIX AND NOT APPLE)
    if (USE_PULSEAUDIO)
        pkg_check_modules(PULSE QUIET IMPORTED_TARGET libpulse-simple)
        if(PULSE_FOUND)
            message(STATUS "Found PulseAudio version = ${PULSE_VERSION}")
            set(HAVE_PULSEAUDIO ON)
        else()
            message(FATAL_ERROR "PulseAudio library not available. Sonivox RT backend can't be built.")
        endif()
    endif()
endif()

set(HAVE_PIPEWIRE OFF)
if(BUILD_RT AND PKG_CONFIG_FOUND AND UNIX AND NOT APPLE)
    if (USE_PIPEWIRE)
        pkg_check_modules (PIPEWIRE QUIET IMPORTED_TARGET libpipewire-0.3)
        if (PIPEWIRE_FOUND)
            message(STATUS "Found PipeWire library version = ${PIPEWIRE_VERSION}")
            set (HAVE_PIPEWIRE ON)
        else()
            set (HAVE_PIPEWIRE OFF)
        endif ()
    endif ()
endif()

set(HAVE_FLUIDSYNTH OFF)
if (BUILD_RT AND PKG_CONFIG_FOUND)
    if (USE_FLUIDSYNTH)
        pkg_check_modules(FLUIDSYNTH QUIET IMPORTED_TARGET fluidsynth>=1.1.1)
        if(FLUIDSYNTH_FOUND)
            message(STATUS "Found FluidSynth version = ${FLUIDSYNTH_VERSION}")
            set(HAVE_FLUIDSYNTH ON)
        else()
            message(FATAL_ERROR "FluidSynth library not available. FluidSynth RT backend can't be built.")
        endif()
    endif()
endif()

set(HAVE_SONIVOX OFF)
if (BUILD_RT AND USE_SONIVOX)
    find_package(sonivox CONFIG QUIET)
    if(sonivox_FOUND)
        message(STATUS "Found Sonivox version = ${sonivox_VERSION}")
        set(HAVE_SONIVOX ON)
    else()
        message(FATAL_ERROR "Sonivox library not available. SonivoxEas Synth RT backend can't be built.")
    endif()
endif()

if (${CMAKE_SYSTEM} MATCHES "Darwin" AND QT_VERSION VERSION_LESS 6.0.0)
    find_package(Qt${QT_VERSION_MAJOR}Concurrent REQUIRED)
    if (Qt${QT_VERSION_MAJOR}Concurrent_FOUND)
        message(STATUS "Found Qt${QT_VERSION_MAJOR}Concurrent version = ${Qt${QT_VERSION_MAJOR}Concurrent_VERSION_STRING}")
    endif()
endif()

# CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2023/06
if (MSVC)
    string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
endif()

message (STATUS "${PROJECT_NAME} v${PROJECT_VERSION}
    CMake version: ${CMAKE_VERSION}
    Install prefix: ${CMAKE_INSTALL_PREFIX}
    Build configuration: ${CMAKE_BUILD_TYPE}
    System: ${CMAKE_SYSTEM_NAME}
    Processor: ${CMAKE_SYSTEM_PROCESSOR}
    Qt Version: ${QT_VERSION}
    D-Bus support: ${HAVE_DBUS}
    Network support: ${HAVE_NETWORK}
    PulseAudio support: ${HAVE_PULSEAUDIO}
    PipeWire support: ${HAVE_PIPEWIRE}
    FluidSynth support: ${HAVE_FLUIDSYNTH}
    Sonivox support: ${HAVE_SONIVOX}
    Building libdrumstick-alsa: ${BUILD_ALSA}
    Building libdrumstick-file: ${BUILD_FILE}
    Building libdrumstick-rt: ${BUILD_RT}
    Building libdrumstick-widgets: ${BUILD_WIDGETS}
    Building tests: ${BUILD_TESTING}
    Building docs: ${BUILD_DOCS}
    Building utils: ${BUILD_UTILS}
    Building frameworks: ${BUILD_FRAMEWORKS}"
)

add_subdirectory(library)
if (BUILD_UTILS)
    add_subdirectory(utils)
endif()
add_subdirectory(icons)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

# translations
add_custom_target( update-translations COMMENT "Updating translations" )

if (BUILD_WIDGETS)
    add_dependencies( update-translations update-widget-translations )
endif()

if (BUILD_UTILS)
    if (BUILD_RT AND BUILD_WIDGETS)
        add_dependencies( update-translations update-vpiano-translations )
    endif()
    if(BUILD_ALSA AND ALSA_FOUND)
        add_dependencies( update-translations update-drumgrid-translations )
        if(BUILD_FILE)
            add_dependencies( update-translations update-guiplayer-translations )
        endif()
    endif()
endif()

# pkg-config support
if ( IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}" )
  set ( pkgconfig_libdir "${CMAKE_INSTALL_LIBDIR}" )
else ()
  set ( pkgconfig_libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}" )
endif ()
if ( IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}" )
  set ( pkgconfig_includedir "${CMAKE_INSTALL_INCLUDEDIR}" )
else ()
  set ( pkgconfig_includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}" )
endif ()

if(UNIX AND NOT APPLE)
    if (BUILD_DOCS)
        find_package(Doxygen REQUIRED dot)
        if(DOXYGEN_FOUND)
            string(REPLACE ";" " " DOXYGEN_INCLUDE_DIRS "${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}")
            configure_file("${CMAKE_SOURCE_DIR}/Doxyfile.in"
                "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" IMMEDIATE @ONLY)
            add_custom_target(doxygen
                ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        endif()
        add_subdirectory(doc)
    endif()
    configure_file(drumstick.spec.in drumstick.spec IMMEDIATE @ONLY)
    if(ALSA_FOUND AND PKG_CONFIG_FOUND)
        configure_file(drumstick-alsa.pc.in drumstick-alsa.pc IMMEDIATE @ONLY)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/drumstick-alsa.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    endif()
    # XML mime types
    set( SHARED_MIME_INFO_MINIMUM_VERSION "0.30" )
    set( XDG_MIME_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/mime/packages" )
    find_package( SharedMimeInfo )
    if( SHARED_MIME_INFO_FOUND )
        install( FILES drumstick.xml DESTINATION ${XDG_MIME_INSTALL_DIR} )
        update_xdg_mimetypes( ${XDG_MIME_INSTALL_DIR} )
    endif()

=== doc/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

find_program(XSLTPROC_EXECUTABLE xsltproc)
if(XSLTPROC_EXECUTABLE)
    message(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    if (NOT RELEASE_DATE)
        execute_process (
            COMMAND bash -c "LANG=en;date +'%B %d, %Y'"
            OUTPUT_VARIABLE RELEASE_DATE
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    endif()
    configure_file(drumstick-devel.doc.txt.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-devel.doc.txt IMMEDIATE @ONLY)
    configure_file(drumstick-drumgrid.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpmid.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpsmf.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumprmi.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumprmi.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpwrk.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml IMMEDIATE @ONLY)
    configure_file(drumstick-metronome.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml IMMEDIATE @ONLY)
    configure_file(drumstick-playsmf.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml IMMEDIATE @ONLY)
    configure_file(drumstick-guiplayer.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml IMMEDIATE @ONLY)
    configure_file(drumstick-sysinfo.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml IMMEDIATE @ONLY)
    configure_file(drumstick-vpiano.xml.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml IMMEDIATE @ONLY)
    include(CreateManpages)
    create_manpages (
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumprmi.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml
    )
else()
    message(STATUS "Warning: XSLTPROC NOT Found. Man pages won't be installed")
endif()

=== icons/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

install(FILES drumstick_16.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps"
    RENAME drumstick.png)

install(FILES drumstick_32.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps"
    RENAME drumstick.png)

install(FILES drumstick_48.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps"
    RENAME drumstick.png)

install(FILES drumstick_64.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps"
    RENAME drumstick.png)

install(FILES drumstick.svgz
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps")

=== library/alsa/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(drumstick-alsa_QTOBJ_SRCS
    ../include/drumstick/alsaclient.h
    ../include/drumstick/alsaevent.h
    ../include/drumstick/alsaport.h
    ../include/drumstick/alsaqueue.h
    ../include/drumstick/alsatimer.h
    ../include/drumstick/playthread.h
)

set(drumstick-alsa_HEADERS
    ../include/drumstick/alsaclient.h
    ../include/drumstick/alsaevent.h
    ../include/drumstick/alsaport.h
    ../include/drumstick/alsaqueue.h
    ../include/drumstick/alsatimer.h
    ../include/drumstick/playthread.h
    ../include/drumstick/sequencererror.h
    ../include/drumstick/subscription.h
    ../include/drumstick/macros.h
)

set(drumstick-alsa_SRCS
    alsaclient.cpp
    alsaevent.cpp
    alsaport.cpp
    alsaqueue.cpp
    alsatimer.cpp
    playthread.cpp
    sequencererror.cpp
    subscription.cpp
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(drumstick-alsa_MOC_SRCS ${drumstick-alsa_QTOBJ_SRCS})
else()
    qt_wrap_cpp(drumstick-alsa_MOC_SRCS ${drumstick-alsa_QTOBJ_SRCS})
endif()

add_library(drumstick-alsa
    ${drumstick-alsa_MOC_SRCS}
    ${drumstick-alsa_SRCS}
    ${drumstick-alsa_HEADERS}
)

add_library(Drumstick::ALSA ALIAS drumstick-alsa)

target_include_directories(drumstick-alsa PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

#message(STATUS "ALSA -- HAVE_DBUS: ${HAVE_DBUS}")

target_compile_definitions(drumstick-alsa PRIVATE
    QT_NO_SIGNALS_SLOTS_KEYWORDS
    $<$<BOOL:${HAVE_DBUS}>:RTKIT_SUPPORT>
)

target_link_libraries(drumstick-alsa PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    PkgConfig::ALSA
)

if(USE_DBUS)
    target_link_libraries(drumstick-alsa PRIVATE
        Qt${QT_VERSION_MAJOR}::DBus
    )
endif()

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-alsa PROPERTIES
        STATIC_LIB "libdrumstick-alsa"
        EXPORT_NAME ALSA
    )
else()
    set_target_properties(drumstick-alsa PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME ALSA
    )
endif()

install(TARGETS drumstick-alsa
    EXPORT drumstick-alsa-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-alsa_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-alsa-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
    NAMESPACE Drumstick::
)

export(EXPORT drumstick-alsa-targets
    NAMESPACE Drumstick::
    FILE ${CMAKE_BINARY_DIR}/drumstick-alsa-targets.cmake
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file( ${CMAKE_BINARY_DIR}/drumstick-alsa-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_file( drumstick-alsa-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-alsa-config.cmake
  @ONLY
)

install(FILES
    ${CMAKE_BINARY_DIR}/drumstick-alsa-config-version.cmake
    ${CMAKE_BINARY_DIR}/drumstick-alsa-config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== library/file/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(drumstick-file_QTOBJ_SRCS
    ../include/drumstick/qsmf.h
    ../include/drumstick/qwrk.h
    ../include/drumstick/rmid.h
)

set(drumstick-file_HEADERS
    ../include/drumstick/macros.h
    ../include/drumstick/qsmf.h
    ../include/drumstick/qwrk.h
    ../include/drumstick/rmid.h
)

if(BUILD_FRAMEWORKS)
    set_source_files_properties(${drumstick-file_HEADERS}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/drumstick
    )
endif()

set(drumstick-file_SRCS
    qsmf.cpp
    qwrk.cpp
    rmid.cpp
)

if (WIN32)
    set(TARGET_DESCRIPTION ${Drumstick_DESCRIPTION})
    set(TARGET_NAME drumstick-file)
    set(TARGET_ORIGINAL_FILENAME libdrumstick-file.dll)
    configure_file(${Drumstick_SOURCE_DIR}/versioninfo.rc.in versioninfo.rc @ONLY)
    list(APPEND drumstick-file_SRCS versioninfo.rc)
endif()

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(drumstick-file_MOC_SRCS ${drumstick-file_QTOBJ_SRCS})
else()
    qt_wrap_cpp(drumstick-file_MOC_SRCS ${drumstick-file_QTOBJ_SRCS})
endif()

add_library(drumstick-file
    ${drumstick-file_MOC_SRCS}
    ${drumstick-file_SRCS}
    ${drumstick-file_HEADERS}
)

add_library(Drumstick::File ALIAS drumstick-file)

target_include_directories(drumstick-file PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(drumstick-file PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
)

target_compile_definitions(drumstick-file PRIVATE
    QT_NO_SIGNALS_SLOTS_KEYWORDS
)

if (QT_VERSION VERSION_GREATER_EQUAL 6.0)
    target_link_libraries(drumstick-file PRIVATE
        Qt6::Core5Compat
    )
endif()


if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-file PROPERTIES
        STATIC_LIB "libdrumstick-file"
        EXPORT_NAME File
    )
else()
    set_target_properties(drumstick-file PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        MACOSX_RPATH TRUE
        EXPORT_NAME File
    )
    if(BUILD_FRAMEWORKS)
        set_target_properties(drumstick-file PROPERTIES
            FRAMEWORK ${BUILD_FRAMEWORKS}
            FRAMEWORK_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
            MACOSX_FRAMEWORK_IDENTIFIER "net.sourceforge.drumstick-file"
            MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake_admin/CustomFrameworkInfo.plist.in"
        )
    endif()
endif()

install(TARGETS drumstick-file
    EXPORT drumstick-file-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-file_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-file-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
    NAMESPACE Drumstick::
)

export(EXPORT drumstick-file-targets
    NAMESPACE Drumstick::
    FILE ${CMAKE_BINARY_DIR}/drumstick-file-targets.cmake
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/drumstick-file-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_file( drumstick-file-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-file-config.cmake
  @ONLY
)

install(FILES
    ${CMAKE_BINARY_DIR}/drumstick-file-config-version.cmake
    ${CMAKE_BINARY_DIR}/drumstick-file-config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== library/rt-backends/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

set(DRUMSTICK_PLUGINS_DIR "drumstick2")

if(FALSE)
    add_subdirectory(dummy-in)
    add_subdirectory(dummy-out)
endif()

if(BUILD_ALSA AND ALSA_FOUND)
    add_subdirectory(alsa-in)
    add_subdirectory(alsa-out)
endif()

if (HAVE_PULSEAUDIO AND HAVE_SONIVOX)
    add_subdirectory(eassynth)
endif()

if(HAVE_NETWORK)
    add_subdirectory(net-in)
    add_subdirectory(net-out)
endif()

if(UNIX AND NOT APPLE AND NOT EMSCRIPTEN)
    add_subdirectory(oss-in)
    add_subdirectory(oss-out)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_subdirectory(mac-in)
    add_subdirectory(mac-out)
    add_subdirectory(macsynth)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_subdirectory(win-in)
    add_subdirectory(win-out)
endif()

if(HAVE_FLUIDSYNTH)
    add_subdirectory(fluidsynth)
endif()

=== library/vpiano-plugin/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt${QT_VERSION_MAJOR}Widgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}UiPlugin REQUIRED)

set(SOURCES
    vpiano-plugin.h
    vpiano-plugin.cpp
    vpiano-plugin.qrc)

add_library(drumstick-vpiano-plugin MODULE ${SOURCES})

target_compile_definitions(drumstick-vpiano-plugin PRIVATE QT_PLUGIN)

target_include_directories(drumstick-vpiano-plugin PRIVATE
    ${Drumstick_SOURCE_DIR}/library/include
)

target_link_libraries(drumstick-vpiano-plugin PRIVATE
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::UiPlugin
    Drumstick::Widgets
)

set_target_properties(drumstick-vpiano-plugin PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/designer)

get_target_property(QT_QMAKE_EXECUTABLE Qt${QT_VERSION_MAJOR}::qmake LOCATION)
execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
  OUTPUT_VARIABLE QT_INSTALL_PLUGINS OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_HOST_PREFIX
  OUTPUT_VARIABLE QT_HOST_PREFIX OUTPUT_STRIP_TRAILING_WHITESPACE
)
string(REPLACE "${QT_HOST_PREFIX}/" "" _INSTALL_PLUGINS  "${QT_INSTALL_PLUGINS}")

install(TARGETS drumstick-vpiano-plugin
    EXPORT drumstick-vpiano-targets
    RUNTIME DESTINATION ${_INSTALL_PLUGINS}/designer
    ARCHIVE DESTINATION ${_INSTALL_PLUGINS}/designer
    LIBRARY DESTINATION ${_INSTALL_PLUGINS}/designer)

=== tests/alsaTest1/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

add_executable (alsaTest1 alsatest1.cpp)

target_link_libraries (alsaTest1 PRIVATE
    Drumstick::ALSA
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
)

add_test (alsaTest1 ${PROJECT_BINARY_DIR}/bin/alsaTest1)

=== tests/fileTest2/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

add_executable (fileTest2 filetest2.cpp)

target_link_libraries (fileTest2 PRIVATE
    Drumstick::File
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
)

if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    target_link_libraries(fileTest2 PRIVATE Qt6::Core5Compat)
endif()

add_test (fileTest2 ${PROJECT_BINARY_DIR}/bin/fileTest2)

=== tests/rtTest/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

set ( SOURCES rttest.cpp )

add_executable ( rtTest ${SOURCES} )

target_include_directories (rtTest PUBLIC
    ${CMAKE_SOURCE_DIR}/library/include )

target_link_libraries (rtTest PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Test
    Drumstick::RT )

if (${CMAKE_SYSTEM} MATCHES "Linux")
    if (BUILD_ALSA AND ALSA_FOUND AND (EXISTS "/dev/snd/") AND (EXISTS "/dev/snd/seq"))
        add_test (rtTest ${PROJECT_BINARY_DIR}/bin/rtTest)
    endif()
else()
    add_test (rtTest ${PROJECT_BINARY_DIR}/bin/rtTest)
endif()

if(STATIC_DRUMSTICK)
    if (FALSE)
        target_compile_definitions(rtTest PUBLIC DUMMY_BACKEND)
        target_link_libraries(rtTest PRIVATE
            drumstick-rt-dummy-in
            drumstick-rt-dummy-out)
    endif()

    if(ALSA_FOUND)
        target_compile_definitions(rtTest PUBLIC LINUX_BACKEND)
        target_link_libraries(rtTest PRIVATE
            drumstick-rt-alsa-in
            drumstick-rt-alsa-out
            drumstick-rt-eassynth)
    endif()

    if(UNIX AND NOT APPLE)
        target_compile_definitions(rtTest PUBLIC OSS_BACKEND)
        target_link_libraries(rtTest PRIVATE
            drumstick-rt-oss-in
            drumstick-rt-oss-out)
    endif()


    if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        target_compile_definitions(rtTest PUBLIC MAC_BACKEND)
        target_link_libraries(rtTest PRIVATE
            drumstick-rt-mac-in
            drumstick-rt-mac-out
            drumstick-rt-macsynth
            "-framework CoreMIDI -framework CoreFoundation")
    endif()

    if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
        target_compile_definitions(rtTest PUBLIC WIN_BACKEND)
        target_link_libraries(rtTest PRIVATE
            drumstick-rt-win-in
            drumstick-rt-win-out
            winmm)
    endif()

    find_package(Qt${QT_VERSION_MAJOR}Network)
    if(Qt${QT_VERSION_MAJOR}Network_FOUND)
        target_compile_definitions(rtTest PUBLIC NET_BACKEND)
        target_link_libraries(rtTest PRIVATE
            drumstick-rt-net-in
            drumstick-rt-net-out)
    endif()

    if(FLUIDSYNTH_FOUND)
        target_compile_definitions(rtTest PUBLIC FLUIDSYNTH_BACKEND)
        target_link_libraries(rtTest PRIVATE drumstick-rt-fluidsynth)
    endif()
endif()

=== utils/dumpsmf/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

set(dumpsmf_SRCS
    dumpsmf.cpp
    dumpsmf.h
)

set(dumpsmf_qtobject_SRCS
    dumpsmf.h
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(dumpsmf_moc_SRCS ${dumpsmf_qtobject_SRCS})
else()
    qt_wrap_cpp(dumpsmf_moc_SRCS ${dumpsmf_qtobject_SRCS})
endif()

add_executable(drumstick-dumpsmf
    ${dumpsmf_moc_SRCS}
    ${dumpsmf_SRCS}
)

target_link_libraries(drumstick-dumpsmf PRIVATE
    Drumstick::File
    Qt${QT_VERSION_MAJOR}::Core
)

if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    target_link_libraries(drumstick-dumpsmf PRIVATE Qt6::Core5Compat)
endif()

install(TARGETS drumstick-dumpsmf
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== utils/dumpwrk/CMakeLists.txt ===
#[===========================================================================[
MIDI C++ Library
Copyright (C) 2005-2024 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
#]===========================================================================]

set(dumpwrk_SRCS
    dumpwrk.cpp
    dumpwrk.h
)

set(dumpwrk_qtobject_SRCS
    dumpwrk.h
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(dumpwrk_moc_SRCS ${dumpwrk_qtobject_SRCS})
else()
    qt_wrap_cpp(dumpwrk_moc_SRCS ${dumpwrk_qtobject_SRCS})
endif()

add_executable(drumstick-dumpwrk
    ${dumpwrk_moc_SRCS}
    ${dumpwrk_SRCS}
)

target_link_libraries(drumstick-dumpwrk PRIVATE
    Drumstick::File
    Qt${QT_VERSION_MAJOR}::Core
)

if(QT_VERSION VERSION_GREATER_EQUAL 6.0.0)
    target_link_libraries(drumstick-dumpwrk PRIVATE Qt6::Core5Compat)
endif()

install(TARGETS drumstick-dumpwrk
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
libdrumstick (2.10.0-1) unstable; urgency=medium

  * New upstream version 2.10.0

 -- Dennis Braun <snd@debian.org>  Sun, 29 Dec 2024 17:48:28 +0100

=== debian/control ===
Source: libdrumstick
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Arnout Engelen <arnouten@bzzt.net>,
 Ross Gammon <rosco2@ubuntu.com>,
 Dennis Braun <snd@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 docbook-xml,
 docbook-xsl,
 doxygen,
 graphviz,
 libasound2-dev,
 libfluidsynth-dev,
 libpulse-dev,
 libqt6core5compat6-dev [ia64],
 libqt6svg6-dev,
 libsonivox-dev,
 qt6-5compat-dev [!ia64],
 qt6-base-dev,
 qt6-tools-dev,
 libx11-dev,
 pkgconf,
 xsltproc
Standards-Version: 4.7.0
Homepage: https://drumstick.sourceforge.net/
Vcs-Git: https://salsa.debian.org/multimedia-team/libdrumstick.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libdrumstick
Rules-Requires-Root: no

Package: libdrumstick-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdrumstick-alsa2t64 (= ${binary:Version}),
 libdrumstick-file2t64 (= ${binary:Version}),
 libdrumstick-rt-backends (= ${binary:Version}),
 libdrumstick-rt2t64 (= ${binary:Version}),
 libdrumstick-widgets2t64 (= ${binary:Version}),
 ${misc:Depends}
Description: Qt6/C++ wrapper for ALSA Sequencer (development files)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides the development files.

Package: libdrumstick-alsa2t64
Provides: ${t64:Provides}
Replaces: libdrumstick-alsa2
Breaks: libdrumstick-alsa2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt6/C++ wrapper for ALSA Sequencer (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides the shared library.

Package: libdrumstick-file2t64
Provides: ${t64:Provides}
Replaces: libdrumstick-file2
Breaks: libdrumstick-file2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: File format support library for drumstick (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the shared library for support of MIDI, Cakewalk and
 RIFF MIDI file formats.

Package: libdrumstick-plugins
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Realtime MIDI I/O with pluggable backends (Qt designer plugins)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the libdrumstick Qt designer plugins.

Package: libdrumstick-rt2t64
Provides: ${t64:Provides}
Replaces: libdrumstick-rt2
Breaks: libdrumstick-rt2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 libdrumstick-rt-backends (= ${binary:Version}),
 rtkit
Description: Realtime MIDI I/O with pluggable backends (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the shared library for realtime MIDI I/O with plugin
 support.

Package: libdrumstick-rt-backends
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Realtime MIDI I/O backends
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the backends for realtime MIDI I/O.

Package: libdrumstick-widgets2t64
Provides: ${t64:Provides}
Replaces: libdrumstick-widgets2
Breaks: libdrumstick-widgets2 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 drumstick-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt6/C++ wrapper for ALSA Sequencer (widgets)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package contains the shared drumstick widgets library.

Package: drumstick-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: Qt6/C++ wrapper for ALSA Sequencer (data files)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides data files for drumstick-tools and libdrumstick-widgets2.

Package: drumstick-tools
Section: sound
Architecture: any
Depends:
 drumstick-data (= ${source:Version}),
 libdrumstick-plugins (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Qt6/C++ wrapper for ALSA Sequencer (utilities)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt6 objects, idioms and style. ALSA sequencer provides software support
 for MIDI technology on Linux. Complementary classes for RMI and WRK file
 processing are also included.
 .
 This package provides utilities shipped with the library:
  - drumstick-drumgrid: Simple Qt drum sequencer.
  - drumstick-dumpmid: Write ALSA MIDI events to STDOUT.
  - drumstick-dumprmi: Write MIDI events from a RIFF MIDI file to STDOUT.
  - drumstick-dumpsmf: Write MIDI events from a MIDI file to STDOUT.
  - drumstick-dumpwrk: Write MIDI events from a Cakewalk WRK file to STDOUT.
  - drumstick-guiplayer: Simple Qt MIDI file player.
  - drumstick-metronome: Headless MIDI metronome.
  - drumstick-playsmf: Headless MIDI file player.
  - drumstick-sysinfo: Display information about ALSA MIDI.
  - drumstick-vpiano: Virtual Piano Keyboard GUI application.

=== debian/watch ===
version=4
https://sf.net/drumstick/drumstick-(.*)\.tar\.gz
